Bug 442577 - Backport fix for possible data corruption in mark_buffer_dirty on SMP [NEEDINFO]
Backport fix for possible data corruption in mark_buffer_dirty on SMP
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
medium Severity medium
: rc
: ---
Assigned To: Mikulas Patocka
Corey Marthaler
http://git.kernel.org/?p=linux/kernel...
:
Depends On:
Blocks: 442579
  Show dependency treegraph
 
Reported: 2008-04-15 12:43 EDT by Mikulas Patocka
Modified: 2009-01-20 15:17 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:17:08 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
cward: needinfo? (bnagendr)


Attachments (Terms of Use)

  None (edit)
Description Mikulas Patocka 2008-04-15 12:43:02 EDT
Description of problem:

Function mark_buffer_dirty() contains SMP-unsafe optimization. If CPU reorders
instructions in certain way, it may cause that modified data are not written and
filesystem corruption happens.

For discussion, see the thread at
http://www.uwsg.indiana.edu/hypermail/linux/kernel/0804.0/0854.html

There are several possible fixes with different performance and complexity (see
the thread), the one that went into upstream kernel is this:
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=1be62dc190ebaca331038962c873e7967de6cc4b;hp=4ed919014eb2b591eb8fdd4dd00226a65faddef4

Version-Release number of selected component (if applicable):
All

How reproducible:
Can't be reproduced, was found during source code review.
If data corruption because of this bug ever happened, it would be very hard to
link the corruption to this problem --- so maybe it would be better to fix the
bug preemtively.
Comment 1 RHEL Product and Program Management 2008-04-15 14:10:00 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 3 Don Zickus 2008-07-25 16:26:44 EDT
in kernel-2.6.18-100.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 7 Chris Ward 2008-11-18 13:11:45 EST
~~ Snapshot 3 is now available ~~ 

Snapshot 3 is now available for Partner Testing, which should contain a fix that resolves this bug. ISO's available as usual at ftp://partners.redhat.com. Your testing feedback is vital! Please let us know if you encounter any NEW issues (file a new bug) or if you have VERIFIED the fix is present and functioning as expected (add PartnerVerified Keyword).

Ping your Partner Manager with any additional questions. Thanks!
Comment 8 Chris Ward 2008-11-28 01:43:43 EST
~~ Attention ~~ Snapshot 4 is now available for testing @ partners.redhat.com ~~

Partners, it is vital that we get your testing feedback on this important bug fix / feature request. If you are unable to test, please clearly indicate this in a comment to this bug or directly with your partner manager. If we do not receive your test feedback, this bug is at risk from being dropped from the release.

If you have VERIFIED the fix, please add PartnerVerified to the Bugzilla Keywords field, along with a description of the test results. 

If you encounter a new bug, CLONE this bug and request from your Partner manager to review. We are no longer excepting new bugs into the release, bar critical regressions.
Comment 9 Chris Ward 2008-12-04 04:18:37 EST
NEC, IBM, others, what is the current status of this bug fix? The fix should be present in the latest RHEL5.3 Snapshot. Please test and send feedback ASAP.
Comment 10 Mikulas Patocka 2008-12-05 08:06:45 EST
It is fixed in the current 5.3 snapshot.

It is fixed with the patch linux-2.6-fs-potential-race-in-mark_buffer_dirty.patch . So any kernels that have this patch have the bug fixed.

The bug is hard to trigger (if it was ever triggered at all? --- it was found during source code review), so there is not much to test on it.
Comment 12 Chris Ward 2008-12-18 05:38:35 EST
~~ Snapshot 6 is out ~~ Partners, please test and let us know if this bug has been fixed. Add PartnerVerified keyword if everything works as expected. For any new issues encountered, CLONE this bug and report the issues in the new bug.
Comment 16 errata-xmlrpc 2009-01-20 15:17:08 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html

Note You need to log in before you can comment on or make changes to this bug.